import processing.serial.*;

import java.awt.Robot;
import java.awt.AWTException;
import java.awt.event.KeyEvent; 

Serial myPort;  // Create object from Serial class
Robot myRobot;

boolean hidden = false;

int state = 255;

int start = 0;
int select = 0;
int A = 0;
int B = 0;
int up = 0;
int right =1;
int down = 0;
int left = 1;

public void setup() 
{
  String filePath = "";
  myPort = new Serial(this, "COM3", 9600);
  try {
    myRobot = new Robot();
  }
  catch (AWTException e) {
    e.printStackTrace();
   }
  filePath = sketchPath("/data/PokemonRed.gb");
  launch(sketchPath("/data/bgb.exe " + "-rom " + filePath));
}
 

void draw() {
  if(!hidden) {
    surface.setVisible(false); //This is what you're looking for.
    hidden = true;
  }
  
  if(myPort.available() > 0) {
    state = myPort.read();
    println(state);
    println(binary(state));
    
    left = state & 1;
    right = (state & 2) >> 1;
    start = (state & 4) >> 2;
    select = (state & 8) >> 3;
    down = (state & 16) >> 4;
    up = (state & 32) >> 5;
    B = (state & 64) >> 6;
    A = (state & 128) >> 7;
    
    print(A);
    /*print(up);
    print(right);
    print(down);
    println(left);
    */
    
  if (start == 1){
    myRobot.keyPress(KeyEvent.VK_ENTER);
  }
  if (select == 1){
    print("works");
    myRobot.keyPress(KeyEvent.VK_SHIFT); 
  }
  if (A == 1){
    myRobot.keyPress(KeyEvent.VK_S); 
  }
  if (B == 1){
    myRobot.keyPress(KeyEvent.VK_A); 
  }
  if(up == 1 && down == 0) {
    myRobot.keyPress(KeyEvent.VK_UP);
  }
  if(right == 0 && left == 1) { 
    myRobot.keyPress(KeyEvent.VK_RIGHT);
  }
  if(down == 1 && up == 0) {
    myRobot.keyPress(KeyEvent.VK_DOWN);
  }
  if(left == 0 && right == 1) {
    myRobot.keyPress(KeyEvent.VK_LEFT);
  }
  
  ///KeyRelease
  if (start == 0){
    myRobot.keyRelease(KeyEvent.VK_ENTER);
  }
  if (select == 0){
    myRobot.keyRelease(KeyEvent.VK_SHIFT); 
  }
  if (A == 0){
    myRobot.keyRelease(KeyEvent.VK_S); 
  }
  if (B == 0){
    myRobot.keyRelease(KeyEvent.VK_A); 
  }
  if(up == 0) {
    myRobot.keyRelease(KeyEvent.VK_UP);
  }
  if(right == 1) { 
    myRobot.keyRelease(KeyEvent.VK_RIGHT);
  }
  if(down == 0) {
    myRobot.keyRelease(KeyEvent.VK_DOWN);
  }
  if(left == 1) {
    myRobot.keyRelease(KeyEvent.VK_LEFT);
  }
 }
}